-- Seasonal Buff Watcher
-- Written by : Rakreo of Duskwood

-- Create hook into Blizzards env table
local env = setmetatable({}, {__index=_G});
-- Attach to the LDB functions
local ldb = LibStub:GetLibrary('LibDataBroker-1.1');
local dataobj = ldb:NewDataObject('TisTheSeason', {type = 'data source', icon = 'Interface\\Icons\\Spell_Nature_TimeStop'});
-- Attach to the Lib Q-Tip functions
local LibQTip = LibStub('LibQTip-1.0');
-- Capture the current Day, Month and Year
local day, month, year = tonumber(date('%d')), tonumber(date('%m')), tonumber(date('%Y'));
--------------------------------------------------------
-- Translation table for all the text in TisTheSeason --
--------------------------------------------------------
local locale, L = GetLocale(), {};
-- Translations for the French client
if (locale == 'frFR') then
	L['Day'] = 'Jour';
	L['Hour'] = 'Heure';
	L['Min'] = 'Minute';
	L['Ready'] = 'Prt';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = 'teignez les incendies !', ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the German client | Thanks Freydis88
elseif (locale == 'deDE') then
	L['Day'] = 'Tag';
	L['Hour'] = 'Stunde';
	L['Min'] = 'Minute';
	L['Ready'] = 'Bereit';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Lscht das Feuer!'] = true, ['Zermatsch den Krbis'] = true, ['"Lasset die Feuer kommen!"'] = true, ['Ruft den kopflosen Reiter'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the Korean client
elseif (locale == 'koKR') then
	L['Day'] = '?';
	L['Hour'] = '??';
	L['Min'] = '?';
	L['Ready'] = '???? ??';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = true, ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the Chinese (simplified) client
elseif (locale == 'zhCN') then
	L['Day'] = 'Day';
	L['Hour'] = 'Hour';
	L['Min'] = 'Min';
	L['Ready'] = 'Ready';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = true, ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the Chinese (traditional) client
elseif (locale == 'zhTW') then
	L['Day'] = 'Day';
	L['Hour'] = 'Hour';
	L['Min'] = 'Min';
	L['Ready'] = 'Ready';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = true, ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the Russian client
elseif (locale == 'ruRU') then
	L['Day'] = 'Day';
	L['Hour'] = 'Hour';
	L['Min'] = 'Min';
	L['Ready'] = 'Ready';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = true, ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the Spanish (Spain) client
elseif (locale == 'esES') then
	L['Day'] = 'Day';
	L['Hour'] = 'Hour';
	L['Min'] = 'Min';
	L['Ready'] = 'Ready';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = true, ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the Spanish (Mexico) client
elseif (locale == 'esMX') then
	L['Day'] = 'Day';
	L['Hour'] = 'Hour';
	L['Min'] = 'Min';
	L['Ready'] = 'Ready';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = true, ['Smash the Pumpkin'] = true, ['"Let the Fires Come!"'] = true, ['Call the Headless Horseman'] = true};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
-- Translations for the English client
else
	L['Day'] = 'Day';
	L['Hour'] = 'Hour';
	L['Min'] = 'Min';
	L['Ready'] = 'Ready';
	L['QUESTS_LoveIsInTheAir'] = {};
	L['QUESTS_HollowsEnd'] = {['Stop the Fires!'] = '|TInterface\\Icons\\Spell_Fire_LavaSpawn:%d|t', ['"Let the Fires Come!"'] = '|TInterface\\Icons\\Spell_Fire_LavaSpawn:%d|t', ['Smash the Pumpkin'] = '|TInterface\\Icons\\INV_Misc_Food_59:%d|t', ['Call the Headless Horseman'] = '|TInterface\\Icons\\Ability_Mount_NightmareHorse:%d|t'};
	L['QUESTS_WintersVeil'] = {};
	L['TisTheSeason'] = 'TisTheSeason';
	L['Realm'] = 'Realm';
end;
--------------------------------------------------------
-- Function to calculate the amount of time remaining --
--------------------------------------------------------
local function FormatTime(s)
	-- Time remaining is greater than 1 day
	if s >= 86400 then
		return format('|cff00ffff%d|r |cff00ff00%s|r', ceil(s/86400), L['Day']);
	-- Time remaining is greater than 1 hour
	elseif s >= 3600 then
		return format('|cff00ffff%d|r |cff00ff00%s|r', ceil(s/3600), L['Hour']);
	-- Time remaining is greater than 1 minute
	elseif s > 0 then
		return format('|cff00ffff%d|r |cff00ff00%s|r', ceil(s/60), L['Min']);
	end;
	-- Time remaining has lapsed
	return format('|cffff9999%s|r', L['Ready']);
end;
------------------------------------------------
-- Create the Seasonal Buffs we need to watch --
------------------------------------------------
-- Define the variables used to track each Holiday
local BuffToWatch, SoundFile, WatchedEvent, DailyQuests;
-- Setup 'Love is in the Air' Season and Buff to watch
if month == 2 and day >= 11 and day <= 16 then
	BuffToWatch = GetSpellInfo(26680); -- 'Adored';
	dataobj.icon = 'Interface\\Icons\\INV_ValentinesBoxOfChocolates02';
	SoundFile = 'Sound\\Creature\\HeadlessHorseman\\Horseman_Laugh_02.wav';
	WatchedEvent = 'Calendar_HallowsEnd';
	DailyQuests = L['QUESTS_LoveIsInTheAir'];
-- Setup 'Hallow's End' Season and Buff to watch
elseif month == 10 and day >= 18 and day <= 31 then
	BuffToWatch = nil; -- GetSpellInfo(24755); -- 'Tricked or Treated' -- Removed in 2011;
	dataobj.icon = 'Interface\\Icons\\Achievement_Halloween_Bat_01';
	SoundFile = 'Interface\\AddOns\\TisTheSeason\\aoogah.ogg';
	WatchedEvent = 'Calendar_HallowsEnd';
	DailyQuests = L['QUESTS_HollowsEnd'];
-- Setup 'Christmas' Season and Buff to watch
elseif (month == 12 and day >= 15 and day <= 31) or (month == 1 and day >= 1 and day <= 2) then
	BuffToWatch = GetSpellInfo(26218); -- 'Mistletoe';
	dataobj.icon = 'Interface\\Icons\\Achievement_WorldEvent_LittleHelper';
	SoundFile = 'Sound\\Creature\\HeadlessHorseman\\Horseman_Laugh_02.wav';
	WatchedEvent = 'Calendar_HallowsEnd';
	DailyQuests = L['QUESTS_WintersVeil'];
end;
-----------------------------------------------------------
-- Function to make sure the DataBase has default values --
-----------------------------------------------------------
local player, realm, CURRENT_VERSION = UnitName('player'), GetRealmName(), GetAddOnMetadata('TisTheSeason', 'Version');
local function InitializeDB()
	-- If there is not TisTheSeasonDB then set it to a blank array
	TisTheSeasonDB = TisTheSeasonDB or {};
	-- Convert the Database to support Version 3.2.2+ new ignore feature
	if not TisTheSeasonDB['version'] or TisTheSeasonDB['version'] < '3.2.1' then TisTheSeasonDB = {}; end;
	-- Make sure the DataBase version gets updated
	TisTheSeasonDB['version'] = CURRENT_VERSION;
	-- Make sure the DataBase has a default ['Sound']
	if TisTheSeasonDB['Sound'] == nil then TisTheSeasonDB['Sound'] = true; end;
	-- Make sure the DataBase has a default ['Reset']
	TisTheSeasonDB['Reset'] = TisTheSeasonDB['Reset'] or 0;
	-- Make sure the DataBase has a default ['IconSize']
	TisTheSeasonDB['IconSize'] = TisTheSeasonDB['IconSize'] or 0;
	-- Make sure the DataBase has a default ['TooltipScale']
	TisTheSeasonDB['TooltipScale'] = TisTheSeasonDB['TooltipScale'] or 1;
		-- Make sure the DataBase has a default ['Ignore']
	TisTheSeasonDB['Ignore'] = TisTheSeasonDB['Ignore'] or {};
	-- Make sure the DataBase has a default ['Realm']
	TisTheSeasonDB['Realm'] = TisTheSeasonDB['Realm'] or {};
	-- Make sure the DataBase has a default ['Realm'][realm]
	TisTheSeasonDB['Realm'][realm] = TisTheSeasonDB['Realm'][realm] or {};
	-- Make sure the DataBase has a default ['Realm'][realm][player]
	TisTheSeasonDB['Realm'][realm][player] = TisTheSeasonDB['Realm'][realm][player] or {['Buff'] = {},['DailyQuests'] = {}};
	-- If there is not TisTheSeasonLog then set it to a blank array
	TisTheSeasonLog = TisTheSeasonLog or {};
	-- Make sure the DataBase has a default PerCharacter['EVENT']
	if WatchedEvent then TisTheSeasonLog[WatchedEvent] = TisTheSeasonLog[WatchedEvent] or {}; end;
end;
-------------------------------------------------------------------------
-- Function to check if any 'Buffs' are no longer 'Events' in the game --
-------------------------------------------------------------------------
local function PurgeBuffs()
	-- Loop thru each Realm
	for realms, toons in pairs(TisTheSeasonDB['Realm']) do
		-- Loop thru each toon in this Realm
		for toon, _ in pairs(toons) do
			-- Loop thru each Buff
			for buff, _ in pairs(TisTheSeasonDB['Realm'][realms][toon]['Buff']) do
				-- If the Buff is no longer 'watchable' then remove it from the watch list
				if BuffToWatch ~= buff then TisTheSeasonDB['Realm'][realms][toon]['Buff'][buff] = nil; end;
			end;
		end;
	end;
end;
--------------------------------------------------------------
-- Function to make sure all new 'Buffs' are marked 'Ready' --
--------------------------------------------------------------
local function SetBuffs()
	-- Make sure we have a real Buff to look for
	if BuffToWatch then
		-- If the Buff has a value then keep it, otherwise set the Expiration time to 0
		TisTheSeasonDB['Realm'][realm][player]['Buff'][BuffToWatch] = TisTheSeasonDB['Realm'][realm][player]['Buff'][BuffToWatch] or 0;
	end;
end;
-------------------------------------------------------
-- Check to see if we currently have a Seasonal Buff --
-------------------------------------------------------
local function CheckBuffs()
	-- Make sure we have a real Buff to look for
	if BuffToWatch then
		-- Query the details of the current Buff for the Buff's Type
		local ExpirationTime = select(7, UnitDebuff('Player', BuffToWatch));
		-- If a 'name' was found then the need to process it further
		if ExpirationTime then
			-- Record this Buff and Expiration Time in the Players database
			TisTheSeasonDB['Realm'][realm][player]['Buff'][BuffToWatch] = (ExpirationTime - GetTime()) + time();
		end;
	end;
end;
----------------------------------------------
-- Update all the Zone/SubZone translations --
----------------------------------------------
local function UpdateTranslations()
	-- Variable used in this function
	local name, year;
	-- Loop thru any Criteria we are tracking for this event
	for name, year in pairs(TisTheSeasonLog[WatchedEvent]) do
		-- Capture the Zone name
		local zone = name:sub(1, name:find(',') - 1);
		-- Capture the SubZone name
		local subzone = name:sub(name:find(',') + 2);
		-- See if there is a translation for the Zone/SubZone
		local trans = translateZone(zone, subzone);
		-- If they name had a translation then remove the old name and update it to the new name
		if trans ~= name then TisTheSeasonLog[WatchedEvent][name] = nil; TisTheSeasonLog[WatchedEvent][trans] = year; end;
	end;
end;
------------------------------------------------------------------------------------------------------------------------------
-- Create a Frame for this addon so we can attach scripts and define the array for the functions that need to be registered --
------------------------------------------------------------------------------------------------------------------------------
local TisTheSeason, events = CreateFrame('Frame'), {};
---------------------------------------------------------------------
-- Fired after the Saved Variables for this addon have been loaded --
---------------------------------------------------------------------
function events:ADDON_LOADED(...)
	-- Hook into the Blizzard_AchievementUI
	if ... == 'Blizzard_AchievementUI' then
		setfenv(AchievementObjectives_DisplayCriteria, env);
	end;
end;
--------------------------------------------------------------------------------------------------------------------------
-- Fired after the player hits the 'Continue' button in the quest-information page, before the 'Complete Quest' button. --
--------------------------------------------------------------------------------------------------------------------------
local QuestComplete;
function events:QUEST_COMPLETE()
	-- Remember the Quest Title for later
	QuestComplete = GetTitleText();
end;
-----------------------------------------------------------------------------------------------
-- Fired whenever the quest frame changes (Detail to Progress to Reward, etc.) or is closed. --
-----------------------------------------------------------------------------------------------
local QuestFinished;
function events:QUEST_FINISHED()
	-- Remember the Quest Title for later
	QuestFinished = GetTitleText();
	-- If we are accepting the 'Candy Bucket' quest then process it
	if QuestFinished == 'Candy Bucket' then
		-- Get the location including any translations
		local currentlocation = translateZone(GetRealZoneText(), GetMinimapZoneText());
		-- Mark the Criteria completed this year
		TisTheSeasonLog[WatchedEvent][currentlocation] = year;
	end;
end;
----------------------------------------------------
-- Translate the Zone and SubZone translated name --
----------------------------------------------------
function translateZone(z, s)
	-- Zone Translation table
	local ZoneTras = {
		['Stormwind City'] = 'Stormwind',
		['City of Ironforge'] = 'Ironforge',
		['The Hinterlands'] = 'Hinterlands',
		['The Exodar'] = 'Exodar',
		['The Barrens'] = 'Barrens',
		['Silvermoon City'] = 'Silvermoon',
		['The Storm Peaks'] = 'Storm Peaks',
		['Sentinel Tower'] = 'Westfall',
		['Scarlet Raven Tavern'] = 'Duskwood',
		['Lakeshire Inn'] = 'Redridge Mountains',
		['Abyssal Depths'] = "Vashj'ir",
		['Shimmering Expanse'] = "Vashj'ir",
		["Kelp'thar Forest"] = "Vashj'ir",
	};
	-- SubZone Translation table
	local SubZoneTras = {
		['Stoutlager Inn'] = 'Thelsamar', -- Loch Modan
		['Deepwater Tavern'] = 'Menethil Harbor', -- Wetlands
		['Sanctum of the Stars'] = "Altar of Sha'tar or Sanctum of the Stars", -- Shadowmoon Valley
		["Altar of Sha'tar"] = "Altar of Sha'tar or Sanctum of the Stars", -- Shadowmoon Valley
		['Trade District'] = 'The Trade District', -- Stormwind
		['Scarlet Raven Tavern'] = 'Darkshire', -- Duskwood
		['The Salty Sailor Tavern'] = 'Booty Bay', -- Stranglethorn Vale
		['Wildhammer Keep'] = 'Aerie Peak', -- The Hinterlands
		['Lakeshire Inn'] = 'Lakeshire', -- Redridge Mountains
		['Ironforge'] = 'The Commons', -- Ironforge
		['Thunderbrew Distillery'] = 'Kharanos', -- Dun Morogh
		['The Exodar'] = 'Seat of the Naaru', -- Exodar
		['Thunder Bluff'] = 'Lower Rise', -- Thunder Bluff
		['Trade Quarter'] = 'The Trade Quarter', -- Undercity
		["Gallows' End Tavern"] = 'Brill', -- Tirisfal Glades
		['Silvermoon City'] = 'The Royal Exchange', -- Silvermoon City
		["Lion's Pride Inn"] = 'Goldshire', -- Elwynn Forest
		['Inn'] = "Aldor Rise or Scryer's Tier", -- Shattrath City
		["A Hero's Welcome"] = 'Silver Enclave', -- Dalaran
		['Cantrips & Crows'] = 'The Underbelly', -- Dalaran
		['Nesingwary Base Camp'] = 'Nessingwary Base Camp', -- Sholazar Basin
		['Westfall Brigade Encampment'] = 'Westfall Brigade', -- Grizzly Hills
		['Westguard Inn'] = 'Westguard Keep', -- Howling Fjord
		['Sentinel Tower'] = 'Sentinel Hill', -- Westfall
		['Nordrassil Inn'] = 'Nordrassil', -- Mount Hyjal
		['Deepholm'] = 'Temple of Earth', -- Deepholm
	};
	-- Build the translated or untranslated name
	local z = ZoneTras[z] or z; local s = SubZoneTras[s] or s;
	-- Return the translated zone information
	return (z..', '..s);
end;
---------------------------------------------------------------------------------------------------
-- Fired whenever the quest log changes. (Frequently, but not as frequently as QUEST_LOG_UPDATE) --
---------------------------------------------------------------------------------------------------
local UnitQuestLogChanged;
function events:UNIT_QUEST_LOG_CHANGED(unit)
	-- Only check if we are the one that caused UNIT_QUEST_LOG_CHANGED to fire
	if unit == 'player' and DailyQuests then
		-- Remember the Quest Title for later
		UnitQuestLogChanged = GetTitleText();
		-- If all 3 Events match then we just completed a quest so process it
		if UnitQuestLogChanged == QuestFinished and UnitQuestLogChanged == QuestComplete then
			-- If the quest we just completed is one we are monitoring then mark it complete today
			if DailyQuests[UnitQuestLogChanged] then TisTheSeasonDB['Realm'][realm][player]['DailyQuests'][UnitQuestLogChanged] = true;
				-- Capture the time the Dailies reset
				TisTheSeasonDB['Reset'] = GetQuestResetTime() + time();
			end;
		end;
	end;
end;
--------------------------------------------------------------------------------------------------------------
-- Fired when a buff, debuff, status, or item bonus was gained by or faded from a player, pet, NPC, or mob. --
--------------------------------------------------------------------------------------------------------------
function events:UNIT_AURA()
-- Check to see if we just gained or lost a seasonal buff
	CheckBuffs();
end;
-----------------------------------------------------------------------------------------------------------------------------
-- Fired when the games first loads or when entering/leaving an instance (Basically anytime the 'Loading' screen is shown) --
-----------------------------------------------------------------------------------------------------------------------------
function events:PLAYER_ENTERING_WORLD()
	-- Make sure the database has been populated with the defaults
	InitializeDB();
	-- Check to see if we are tracking any Seasons that have passed
	PurgeBuffs();
	-- Make sure we mark any new Buff's as Ready
	SetBuffs();
	-- Check to see if we gained or lost a seasonal buff
	CheckBuffs();
	-- Update translations
	UpdateTranslations();
end;
----------------------------------------------------------------------------------------------------------
-- Set the 'OnEvent' trigger assigned to PetShop and execute the function based on the Event that fired --
----------------------------------------------------------------------------------------------------------
TisTheSeason:SetScript('OnEvent', function(self, event, ...) events[event](self, ...); end);
-- Loop thru all the 'events' array and register the 'Events'
for k, v in pairs(events) do
	-- Register all events for which handlers have been defined
	TisTheSeason:RegisterEvent(k);
end;

------------------------------------------------------------------------------------------------
-- Scan the database every 5 seconds and Show an alert in LDB if we have a toon that is ready --
------------------------------------------------------------------------------------------------
local elapsed, alertsound = 0, false;
TisTheSeason:SetScript('OnUpdate', function(self, elap)
	-- Define some variables for use in the function
	local remain, lowest = 0, 999999;
	-- Calculate the Elasped time
	elapsed = elapsed + elap;
	-- If we have not waited long enough then just return
	if elapsed < 5 then return; end;
	-- We waited long enough so reset the delay counter
	elapsed = 0;
	-- Loop thru each Realm
	for realms, toons in pairs(TisTheSeasonDB['Realm']) do
		-- Loop thru each toon in this Realm
		for toon, _ in pairs(toons) do
			-- See if we are Ignoring this toon
			if not TisTheSeasonDB['Ignore'][realms..'-'..toon] then
				-- Loop thru each Buff
				for buff, expire in pairs(TisTheSeasonDB['Realm'][realms][toon]['Buff']) do
					-- Calculate the number of seconds remaining
					remain = expire - time();
					-- Remember the lowest number we see
					if remain < lowest then lowest = remain; end;
				end;
			end;
		end;
	end;
	if lowest == 999999 then
		dataobj.text = '';
	else
		dataobj.text = FormatTime(lowest);
		if tonumber(lowest) <= 0 and alertsound == false then
			if TisTheSeasonDB['Sound'] then PlaySoundFile(SoundFile); end;
			alertsound = true;
		end;
	end;
	if tonumber(lowest) > 0 then alertsound = false; end;
	-- See if it is time to reset the Dailies
	if TisTheSeasonDB['Reset'] < time() then
		-- Loop thru each Realm
		for realms, toons in pairs(TisTheSeasonDB['Realm']) do
			-- Loop thru each toon in this Realm
			for toon, _ in pairs(toons) do
				-- Loop thru each Toon
				TisTheSeasonDB['Realm'][realms][toon]['DailyQuests'] = {};
			end;
		end;
	end;
	-- Rescan for Buffs
	CheckBuffs();
end);

---------------------------------------------------------
-- Create the Tooltip when we mouseover the LDB source --
---------------------------------------------------------
function dataobj:OnEnter()
	if BuffToWatch or DailyQuests then
		-- Acquire a Tooltip with 2 columns
		local tooltip = LibQTip:Acquire('TisTheSeason', 2, 'LEFT', 'RIGHT');
		self.tooltip = tooltip;
		-- Define the Font for the Tooltip Header
		local TooltipHeaderFont = CreateFont('TooltipHeaderFont');
		TooltipHeaderFont:CopyFontObject(GameTooltipText);
		TooltipHeaderFont:SetTextColor(0.2, 1.0, 0.2, 1.0);
		tooltip:SetHeaderFont(TooltipHeaderFont);
		-- Define the Font for the Tooltip Text
		local TooltipFont = CreateFont('TooltipFont');
		TooltipFont:CopyFontObject(GameTooltipText);
		TooltipFont:SetTextColor(0.9, 0.7, 1.0, 1.0);
		tooltip:SetFont(TooltipFont);
		-- Add the Header to the TooltipFont
		local header = BuffToWatch or 'Dailies';
		tooltip:AddHeader(L['TisTheSeason'], '|cff66cccc'..header..'|r');
		-- Add a Seperator to the tooltip
		tooltip:AddSeparator(2, 0.5, 0.5, 1.0);
		-- Loop thru each Realm
		for realms, toons in pairs(TisTheSeasonDB['Realm']) do
			-- Add the Realm to the tooltip
			tooltip:AddLine('|cffffcc00'..L['Realm']..'|r : |cff33ffcc'..realms..'|r');
			-- Loop thru each toon in this Realm
			for toon, _ in pairs(toons) do
				-- See if we are Ignoring this toon
				if not TisTheSeasonDB['Ignore'][realms..'-'..toon] then
					-- Clear the icons for the Dailies
					local dailies = '';
					for quest, icon in pairs(TisTheSeasonDB['Realm'][realms][toon]['DailyQuests']) do
						if icon then dailies = dailies..DailyQuests[quest]:format(TisTheSeasonDB['IconSize']); end;
					end;
					counter = 'Dailies';
					for buff, expire in pairs(TisTheSeasonDB['Realm'][realms][toon]['Buff']) do
						counter = FormatTime(expire - time());
					end;
					tooltip:AddLine(' '..dailies..toon, counter);
				end;
			end;
		end;
		-- Use smart anchoring code to anchor the tooltip to our frame
		tooltip:SmartAnchorTo(self);
		-- Show it, et voil !
		tooltip:SetScale(TisTheSeasonDB['TooltipScale']);
		tooltip:Show();
	end;
end;

---------------------------------------------------------
-- Hide the Tooltip when we mouseout of the LDB source --
---------------------------------------------------------
function dataobj:OnLeave()
	-- Release the Tooltip
	LibQTip:Release(self.tooltip);
	-- Clear the Tooltip
	self.tooltip = nil;
end;

-----------------------------------------------------------------------------
-- Function to intercept Achievement Criteria if it is for a Watched Event --
-----------------------------------------------------------------------------
function env.GetAchievementCriteriaInfo(...)
	-- Get the information for the Achievement
	local id, i = ...;
	-- If the Achievement ID is not one we are tracking then just pass the original data back
	if type(id) == "number" and (id == 963 or id == 966 or id == 969 or id == 5836 or id == 5837) then return process(id, GetAchievementCriteriaInfo(...)); end;
	-- The Achievement ID is one we are tracking so process it
	return GetAchievementCriteriaInfo(...);
end;

--------------------------------------------------------------------
-- Function to add the date completed to the Achievement Criteria --
--------------------------------------------------------------------
function process(id, ...)
	-- Capture the data from GetAchievementCriteriaInfo(...)
	local name, ctype, lcompleted = ...;
	-- If we have data for this Criteria then process it
	if WatchedEvent and TisTheSeasonLog[WatchedEvent][name] then
		-- Check to see if the Criteria was completed this year
		if TisTheSeasonLog[WatchedEvent][name] == year then
			color = "ffff99";
		-- Must have been a previous year
		else
			color = "2222cc";
		end;
		-- Return the "reformatted" Criteria with the date added to the end
		return ("%s |cff%s(%s)|r"):format((...), color, TisTheSeasonLog[WatchedEvent][name]), select(2, ...);
	-- We do not have data so just return the Criteria without modification
	else
		return ...;
	end;
end;

---------------------------------------------------------------
-- Function to process the SLASH commands used by this addon --
---------------------------------------------------------------
-- Setup the /slash commands for this addon
SLASH_TISTHESEASON1 = '/tts'; SLASH_TISTHESEASON2 = '/tistheseason';
-- Process the /slash command
function SlashCmdList.TISTHESEASON(msg, toon)
	-- Strip out any arguments from the command that was passed
	local command, rest = msg:match('^(%S*)%s*(.-)$');
	-- Convert the Command into Lowercase
	command = string.lower(command);
	-- If the user typed '/tts sound' then set the sound preferences
	if command == 'sound' then
		-- Convert the Rest into Lowercase
		rest = string.upper(rest);
		-- If they did not specify the Toggle the sound
		if rest == 'TOGGLE' then
			TisTheSeasonDB['Sound'] = not TisTheSeasonDB['Sound'];
		-- Turn the Sound ON
		elseif rest == 'ON' then
			TisTheSeasonDB['Sound'] = true;
		-- Turn the Sound OFF
		elseif rest == 'OFF' then
			TisTheSeasonDB['Sound'] = false;
		else
			DEFAULT_CHAT_FRAME:AddMessage('|cffffff33/tts sound [ON||OFF||TOGGLE]|r for the Alarm Sound');
		end;
		-- Build the textual representation of the current Sound setting
		local sound = TisTheSeasonDB['Sound'] and '33ff33ON' or 'ff3333OFF';
		DEFAULT_CHAT_FRAME:AddMessage('TisTheSeason sound is now |cff'..sound..'|r');
	-- If the user typed '/tts ignore' then process it
	elseif command == 'ignore' then
		-- If we do not have a toons name then assume this toons
		if rest == '' then rest = player end;
		-- Convert the first character of the Toons name to Uppercase
		local ignore = string.gsub(string.lower(rest), "^%l", string.upper);
		-- If the current toon is being ignored then stop ignoring this toon
		if TisTheSeasonDB['Ignore'][realm..'-'..ignore] then
			DEFAULT_CHAT_FRAME:AddMessage('|cff5599ff'..ignore..'|r is no longer being ignored', 1, 1, 0);
			TisTheSeasonDB['Ignore'][realm..'-'..ignore] = nil;
		-- The current toon was not being ignored so start ignoring this toon
		else
			DEFAULT_CHAT_FRAME:AddMessage('|cff5599ff'..ignore..'|r is now being ignored', 1, 1, 0);
			TisTheSeasonDB['Ignore'][realm..'-'..ignore] = true;
		end;
	-- If the user typed '/tts icon' then process it
	elseif command == 'icon' then
		if rest == '' then
			DEFAULT_CHAT_FRAME:AddMessage('TisTheSeason icon size is now '..TisTheSeasonDB['IconSize']);
		else
			TisTheSeasonDB['IconSize'] = tonumber(rest) or 0;
		end;
	-- If the user typed '/tts scale' then process it
	elseif command == 'scale' then
		if rest == '' then
			DEFAULT_CHAT_FRAME:AddMessage('TisTheSeason Tooltip Scale is now '..TisTheSeasonDB['TooltipScale']);
		else
			TisTheSeasonDB['TooltipScale'] = tonumber(rest) or 1;
		end;
	elseif command == 'bucket' then
		-- Get the location including any translations
		local currentlocation = translateZone(GetRealZoneText(), GetMinimapZoneText());
		-- Mark the Criteria completed this year
		TisTheSeasonLog[WatchedEvent][currentlocation] = year;
		-- DEBUG code for me only
		print('Current Location = '..currentlocation);
	elseif command == 'test' then
	-- Variable used in this function
	local name, year;
	-- Loop thru any Criteria we are tracking for this event
	for name, year in pairs(TisTheSeasonLog[WatchedEvent]) do
		-- Capture the Zone name
		local zone = name:sub(1, name:find(',') - 1);
		-- Capture the SubZone name
		local subzone = name:sub(name:find(',') + 2);
		-- See if there is a translation for the Zone/SubZone
		local trans = translateZone(zone, subzone);
		print (trans..' : '..name);
		if trans ~= name then print('They do not match'); TisTheSeasonLog[WatchedEvent][name] = nil; TisTheSeasonLog[WatchedEvent][trans] = year; end;
	end;
	else
		DEFAULT_CHAT_FRAME:AddMessage('|cffffff33/tts sound [ON||OFF||TOGGLE]|r for the Alarm Sound');
		DEFAULT_CHAT_FRAME:AddMessage('|cffffff33/tts ignore [TOON]|r to toggle ignoring a Toon on THIS Realm');
		DEFAULT_CHAT_FRAME:AddMessage('|cffffff33/tts icon [Size 0 - 64]|r to change the Daily Icon size');
	end;
end;

DEFAULT_CHAT_FRAME:AddMessage('|cff22ff00TisTheSeason '..CURRENT_VERSION..'|r - use |cffffffff/tts|r or |cffffffff/tistheseason|r for options', 1, 1, 0);